Package org.tanukisoftware.wrapper

# Class WrapperProcessInputStream

java.lang.Object
java.io.InputStream
org.tanukisoftware.wrapper.WrapperProcessInputStream

All Implemented Interfaces:
  `Closeable`, `AutoCloseable`

public class WrapperProcessInputStream extends InputStream
The InputStream Class of a WrapperProcess, representing all the data the ChildProcess writes to the Wrapper.

Since:
  Wrapper 3.4.0

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Closes the InputStream
`boolean`
`markSupported()`
Tests if this input stream supports the mark and reset methods.
`int`
`read()`
Read a character from the Stream and moves the position in the stream
`int`
`read(byte[] b)`
Reads some number of bytes from the input stream and stores them into the buffer array b.
`int`
`read(byte[] b, int off, int len)`
Reads up to len bytes of data from the input stream into an array of bytes.
`boolean`
`ready()`

### Methods inherited from class java.io.InputStream

`available, mark, nullInputStream, readAllBytes, readNBytes, readNBytes, reset, skip, skipNBytes, transferTo`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### close

public void close() throws IOException
Closes the InputStream

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Overrides:
  `close` in class `InputStream`
Throws:
  `IOException` - in case of any file errors
  `WrapperLicenseError` - If the function is called other than in the Professional Edition or from a Standalone JVM.

### markSupported

public boolean markSupported()
Tests if this input stream supports the mark and reset methods. The markSupported method of InputStream returns false.

Overrides:
  `markSupported` in class `InputStream`
Returns:
  false.

### ready

public boolean ready()

Returns:
  TRUE if ready, otherwise FALSE.

### read

public int read() throws IOException
Read a character from the Stream and moves the position in the stream

Specified by:
  `read` in class `InputStream`
Returns:
  A single character from the stream, or -1 when the end of stream is reached.
Throws:
  `IOException` - in case the stream has been already closed or any other file error
  `WrapperLicenseError` - If the function is called other than in the Professional Edition or from a Standalone JVM.

### read

public int read(byte[] b) throws IOException
Reads some number of bytes from the input stream and stores them into the buffer array b. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown. If the length of b is zero, then no bytes are read and 0 is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at the end of the file, the value -1 is returned; otherwise, at least one byte is read and stored into b. The first byte read is stored into element b[0], the next one into b[1], and so on. The number of bytes read is, at most, equal to the length of b. Let k be the number of bytes actually read; these bytes will be stored in elements b[0] through b[k-1], leaving elements b[k] through b[b.length-1] unaffected. The read(b) method for class InputStream has the same effect as: read(b, 0, b.length)

Overrides:
  `read` in class `InputStream`
Parameters:
  `b` - The buffer into which the data is read.
Returns:
  The total number of bytes read into the buffer, or -1 is there is no more data because the end of the stream has been reached.
Throws:
  `IOException` - If the first byte cannot be read for any reason other than the end of the file, if the input stream has been closed, or if some other I/O error occurs.
  `WrapperLicenseError` - If the function is called other than in the Professional Edition or from a Standalone JVM.

### read

public int read(byte[] b, int off, int len) throws IOException
Reads up to len bytes of data from the input stream into an array of bytes. An attempt is made to read as many as len bytes, but a smaller number may be read. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown. If len is zero, then no bytes are read and 0 is returned; otherwise, there is an attempt to read at least one byte. If no byte is available because the stream is at end of file, the value -1 is returned; otherwise, at least one byte is read and stored into b. The first byte read is stored into element b[off], the next one into b[off+1], and so on. The number of bytes read is, at most, equal to len. Let k be the number of bytes actually read; these bytes will be stored in elements b[off] through b[off+k-1], leaving elements b[off+k] through b[off+len-1] unaffected. In every case, elements b[0] through b[off] and elements b[off+len] through b[b.length-1] are unaffected.

Overrides:
  `read` in class `InputStream`
Parameters:
  `b` - The buffer into which the data is read.
  `off` - The start offset in array b from which the data is read.
  `len` - The maximum number of bytes to read.
Returns:
  The total number of bytes read into the buffer, or -1 is there is no more data because the end of the stream has been reached.
Throws:
  `IOException` - If the first byte cannot be read for any reason other than the end of the file, if the input stream has been closed, or if some other I/O error occurs.
  `WrapperLicenseError` - If the function is called other than in the Professional Edition or from a Standalone JVM.